
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>

#define RED 1
#define GREEN 2
#define NO_LEDS 9
#define N 3
#define TIE 3

typedef struct led_color{
	int red;
	int green;
} LED_color;


LED_color leds[NO_LEDS];

int led_matrix[N][N];
int buttons[NO_LEDS];
int light_led[NO_LEDS];

int winner_led_red;
int winner_led_green;

int winner;
int player = RED;

void initLED(void) {

	//initializare led-uri
	leds[0].red = PA0;
	leds[0].green = PA1;

	leds[1].red = PA2;
	leds[1].green = PA3;

	leds[2].red = PA4;
	leds[2].green = PA5;

	leds[3].red = PA6;
	leds[3].green = PA7;

	leds[4].red = PC0;
	leds[4].green = PC1;

	leds[5].red = PC2;
	leds[5].green = PC3;

	leds[6].red = PC4;
	leds[6].green = PC5;

	leds[7].red = PC6;
	leds[7].green = PC7;
		
	leds[8].red = PB0;
	leds[8].green = PB1;

	//scor
	winner_led_red = PB3;
	winner_led_green = PB4;

}

void initButtons(void) {

	//initializare butoane
	buttons[0] = PD0;
	buttons[1] = PD1;
	buttons[2] = PD2;
	buttons[3] = PD3;
	buttons[4] = PD4;
	buttons[5] = PD5;
	buttons[6] = PD6;
	buttons[7] = PD7;
	buttons[8] = PB6;
}

void initGame(void) {

	for (int i = 0; i < NO_LEDS; i++) {
		light_led[i] = 0;
	}

	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			led_matrix[i][j] = 0;
		}
	}

	//setare led-uri
	DDRA |= (1 << leds[0].red);
	DDRA |= (1 << leds[0].green);
	PORTA &= ~(1 << leds[0].red);
	PORTA &= ~(1 << leds[0].green);

	DDRA |= (1 << leds[1].red);
	DDRA |= (1 << leds[1].green);
	PORTA &= ~(1 << leds[1].red);
	PORTA &= ~(1 << leds[1].green);

	DDRA |= (1 << leds[2].red);
	DDRA |= (1 << leds[2].green);
	PORTA &= ~(1 << leds[2].red);
	PORTA &= ~(1 << leds[2].green);

	DDRA |= (1 << leds[3].red);
	DDRA |= (1 << leds[3].green);
	PORTA &= ~(1 << leds[3].red);
	PORTA &= ~(1 << leds[3].green);

	DDRC |= (1 << leds[4].red);
	DDRC |= (1 << leds[4].green);
	PORTC &= ~(1 << leds[4].red);
	PORTC &= ~(1 << leds[4].green);

	DDRC |= (1 << leds[5].red);
	DDRC |= (1 << leds[5].green);
	PORTC &= ~(1 << leds[5].red);
	PORTC &= ~(1 << leds[5].green);

	DDRC |= (1 << leds[6].red);
	DDRC |= (1 << leds[6].green);
	PORTC &= ~(1 << leds[6].red);
	PORTC &= ~(1 << leds[6].green);

	DDRC |= (1 << leds[7].red);
	DDRC |= (1 << leds[7].green);
	PORTC &= ~(1 << leds[7].red);
	PORTC &= ~(1 << leds[7].green);

	DDRB |= (1 << leds[8].red);
	DDRB |= (1 << leds[8].green);
	PORTB &= ~(1 << leds[8].red);
	PORTB &= ~(1 << leds[8].green);

	// //setare scor
	DDRB |= (1 << winner_led_red);
	PORTB &= ~(1 << winner_led_red);
	
	DDRB |= (1 << winner_led_green);
	PORTB &= ~(1 << winner_led_green);

	//setare butoane
	DDRD &= ~(1 << buttons[0]);
	PORTD |= (1 << buttons[0]);

	DDRD &= ~(1 << buttons[1]);
	PORTD |= (1 << buttons[1]);

	DDRD &= ~(1 << buttons[2]);
	PORTD |= (1 << buttons[2]);

	DDRD &= ~(1 << buttons[3]);
	PORTD |= (1 << buttons[3]);

	DDRD &= ~(1 << buttons[4]);
	PORTD |= (1 << buttons[4]);

	DDRD &= ~(1 << buttons[5]);
	PORTD |= (1 << buttons[5]);

	DDRD &= ~(1 << buttons[6]);
	PORTD |= (1 << buttons[6]);
	
	DDRD &= ~(1 << buttons[7]);
	PORTD |= (1 << buttons[7]);

	DDRB &= ~(1 << buttons[8]);
	PORTB |= (1 << buttons[8]);

	//winner
	winner = 0;

}

void change_player(void) {

	if (player == RED)
		player = GREEN;
	else
		player = RED;

}

void lightLed(int led) {

	if (light_led[led] == 0) {

		switch(led) {

			case 0:

				if (player == RED) {
					PORTA |= (1 << leds[0].red);
					led_matrix[0][0] = RED;
				}
				else {
					PORTA |= (1 << leds[0].green);
					led_matrix[0][0] = GREEN;
				}
				break;

			case 1:

				if (player == RED) {
					PORTA |= (1 << leds[1].red);
					led_matrix[0][1] = RED;
				}
				else {
					PORTA |= (1 << leds[1].green);
					led_matrix[0][1] = GREEN;
				}
				break;

			case 2:

				if (player == RED) {
					PORTA |= (1 << leds[2].red);
					led_matrix[0][2] = RED;
				}
				else {
					PORTA |= (1 << leds[2].green);
					led_matrix[0][2] = GREEN;
				}
				break;

			case 3:

				if (player == RED) {
					PORTA |= (1 << leds[3].red);
					led_matrix[1][0] = RED;
				}
				else {
					PORTA |= (1 << leds[3].green);
					led_matrix[1][0] = GREEN;
				}
				break;

			case 4:

				if (player == RED) {
					PORTC |= (1 << leds[4].red);
					led_matrix[1][1] = RED;
				}
				else {
					PORTC |= (1 << leds[4].green);
					led_matrix[1][1] = GREEN;
				}
				break;

			case 5:

				if (player == RED) {
					PORTC |= (1 << leds[5].red);
					led_matrix[1][2] = RED;
				}
				else {
					PORTC |= (1 << leds[5].green);
					led_matrix[1][2] = GREEN;
				}
				break;

			case 6:

				if (player == RED) {
					PORTC |= (1 << leds[6].red);
					led_matrix[2][0] = RED;
				}
				else {
					PORTC |= (1 << leds[6].green);
					led_matrix[2][0] = GREEN;
				}
				break;

			case 7:

				if (player == RED) {
					PORTC |= (1 << leds[7].red);
					led_matrix[2][1] = RED;
				}
				else {
					PORTC |= (1 << leds[7].green);
					led_matrix[2][1] = GREEN;
				}
				break;

			case 8:

				if (player == RED) {
					PORTB |= (1 << leds[8].red);
					led_matrix[2][2] = RED;
				}
				else {
					PORTB |= (1 << leds[8].green);
					led_matrix[2][2] = GREEN;
				}
				break;

		}

		light_led[led] = player;
		change_player();

	}

}

void getWinner(void) {

	//orizontal 1
	if (led_matrix[0][0] == RED && led_matrix[0][1] == RED && led_matrix[0][2] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][0] == GREEN && led_matrix[0][1] == GREEN && led_matrix[0][2] == GREEN) {
		winner = GREEN;
		return;
	}

	//orizontal 2
	if (led_matrix[1][0] == RED && led_matrix[1][1] == RED && led_matrix[1][2] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[1][0] == GREEN && led_matrix[1][1] == GREEN && led_matrix[1][2] == GREEN) {
		winner = GREEN;
		return;
	}

	//orizontal 3
	if (led_matrix[2][0] == RED && led_matrix[2][1] == RED && led_matrix[2][2] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[2][0] == GREEN && led_matrix[2][1] == GREEN && led_matrix[2][2] == GREEN) {
		winner = GREEN;
		return;
	}

	//vertical 1
	if (led_matrix[0][0] == RED && led_matrix[1][0] == RED && led_matrix[2][0] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][0] == GREEN && led_matrix[1][0] == GREEN && led_matrix[2][0] == GREEN) {
		winner = GREEN;
		return;
	}

	//vertical 2
	if (led_matrix[0][1] == RED && led_matrix[1][1] == RED && led_matrix[2][1] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][1] == GREEN && led_matrix[1][1] == GREEN && led_matrix[2][1] == GREEN) {
		winner = GREEN;
		return;
	}

	//vertical 3
	if (led_matrix[0][2] == RED && led_matrix[1][2] == RED && led_matrix[2][2] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][2] == GREEN && led_matrix[1][2] == GREEN && led_matrix[2][2] == GREEN) {
		winner = GREEN;
		return;
	}

	//diagonal 1
	if (led_matrix[0][0] == RED && led_matrix[1][1] == RED && led_matrix[2][2] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][0] == GREEN && led_matrix[1][1] == GREEN && led_matrix[2][2] == GREEN) {
		winner = GREEN;
		return;
	}

	//diagonal 2
	if (led_matrix[0][2] == RED && led_matrix[1][1] == RED && led_matrix[2][0] == RED) {
		winner = RED;
		return;
	}

	if (led_matrix[0][2] == GREEN && led_matrix[1][1] == GREEN && led_matrix[2][0] == GREEN) {
		winner = GREEN;
		return;
	}

	//egalitate
	if (led_matrix[0][0] != 0 && led_matrix[0][1] != 0 && led_matrix[0][2] != 0 &&
		led_matrix[1][0] != 0 && led_matrix[1][1] != 0 && led_matrix[1][2] != 0 &&
		led_matrix[2][0] != 0 && led_matrix[2][1] != 0 && led_matrix[2][2] != 0) {
			winner = TIE;
			return;
	}

}

void light_winner() {

	switch(winner) {

		case RED:
			PORTB |= (1 << winner_led_red);
			break;

		case GREEN:
			PORTB |= (1 << winner_led_green);
			break;

		 case TIE:
		 	PORTB &= ~(1 << winner_led_red);
		 	PORTB &= ~(1 << winner_led_green);
		 	
		 	break;
			
	}
	winner = 0;

}

void playGame(void) {

	while(1){

		if ((PIND & (1 << buttons[0])) == 0) {
			lightLed(0);
		}
		if ((PIND & (1 << buttons[1])) == 0) {
			lightLed(1);
		}
		if ((PIND & (1 << buttons[2])) == 0) {
			lightLed(2);
		}
		if ((PIND & (1 << buttons[3])) == 0) {
			lightLed(3);
		}
		if ((PIND & (1 << buttons[4])) == 0) {
			lightLed(4); 
		}
		if ((PIND & (1 << buttons[5])) == 0) {
			lightLed(5);
		}
		if ((PIND & (1 << buttons[6])) == 0) {
			lightLed(6);
		}
		if ((PIND & (1 << buttons[7])) == 0) {
			lightLed(7);
		}
		if ((PINB & (1 << buttons[8])) == 0) {
			lightLed(8);
		}

		getWinner();

		if (winner != 0) {
		 	light_winner();
		}
	

	}
}

int main(void) {
	
	initLED();
	initButtons();
	initGame();

	playGame();

	return 0;
}
